#ifndef __RTK_H__
#define __RTK_H__

// david ----------------------------------------------------------------
#ifdef BK
	#define FW_SIGNATURE			((char *)"bkln")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"csro")	// fw signature with root fs
	#define ROOT_SIGNATURE          ((char *)"BKRT")	
#elif defined(TR)
	#define FW_SIGNATURE			((char *)"trln")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"csro")	// fw signature with root fs
	#define ROOT_SIGNATURE          ((char *)"trrt")	
#elif defined(AC)
	#define FW_SIGNATURE			((char *)"acln")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"csro")	// fw signature with root fs
	#define ROOT_SIGNATURE          ((char *)"acrt")		
#elif defined(KLD)
	#define FW_SIGNATURE			((char *)"klln")	// fw signature
	//for 615
	#define FW_SIGNATURE_WITH_ROOT_615	((char *)"k1ln")	// fw signature with root fs
	#define ROOT_SIGNATURE_615          ((char *)"k1rt")		
	//for 635
	#define FW_SIGNATURE_WITH_ROOT_635	((char *)"k2ln")	// fw signature with root fs
	#define ROOT_SIGNATURE_635          ((char *)"k2rt")				
	//for 300n
	#define FW_SIGNATURE_WITH_ROOT_300N	((char *)"k3ln")	// fw signature with root fs
	#define ROOT_SIGNATURE_300N          ((char *)"k3rt")		
	//for 605
	#define FW_SIGNATURE_WITH_ROOT_605	((char *)"k4ln")	// fw signature with root fs
	#define ROOT_SIGNATURE_605          ((char *)"k4rt")
#elif defined(CONFIG_RTL865X_SC)
	#define FW_SIGNATURE			((char *)"SCLN")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"SCRO")	// fw signature with root fs
	#define ROOT_SIGNATURE			((char *)"SCRT")
#elif defined(RTL8196B) && !defined(RTL8197B)
	#define FW_SIGNATURE			((char *)"cs6b")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"cr6b")	// fw signature with root fs
//	#define FW_SIGNATURE_WITH_ROOT	((char *)"jwnr")	// DNI fw signature with root fs
	#define ROOT_SIGNATURE          ((char *)"r6br")
#else
	#define FW_SIGNATURE			((char *)"csys")	// fw signature
	#define FW_SIGNATURE_WITH_ROOT	((char *)"csro")	// fw signature with root fs
	#define ROOT_SIGNATURE          ((char *)"root")
#endif

#define SQSH_SIGNATURE		((char *)"sqsh")

#if defined(RTL8196B) && !defined(RTL8197B)
#define WEB_SIGNATURE		((char *)"w6bp")
#else
#define WEB_SIGNATURE		((char *)"webp")
#endif

#define BOOT_SIGNATURE		((char *)"boot")
#define ALL1_SIGNATURE		((char *)"ALL1")
#define ALL2_SIGNATURE		((char *)"ALL2")

#define HW_SETTING_OFFSET		0x6000

// Cyrus ----------------------------------------------------------------
#define HW_SIGNATURE		((char *)"HS")	// hw signature
#define SW_SIGNATURE_D		((char *)"DS")	// sw_default signature
#define SW_SIGNATURE_C		((char *)"CS")	// sw_current signature
#define SIG_LEN			4

/* Firmware image header */
typedef struct _header_ {
	unsigned char signature[SIG_LEN];
	unsigned long startAddr;
	unsigned long burnAddr;
	unsigned long len;
} IMG_HEADER_T, *IMG_HEADER_Tp;

typedef struct _signature__ {
	unsigned char *signature;
	unsigned char *comment ;
	int sig_len;
	int skip ;
	int maxSize;
	int reboot;
} SIGN_T ;

#endif

