
#include <linux/interrupt.h>
#include <asm/system.h>
#include "monitor.h"
#include "etherboot.h"
#include "nic.h"

#include <asm/mipsregs.h>	//wei add
#if SPI_FLASH
#include "spi_flash.h"
#endif
#ifdef RTL8186
#include <asm/rtl8181.h>

//#define SUPPORT_NAND 1 
#endif

#if defined(RTL865X) || defined(RTL8196B)
#include <asm/rtl865x.h>
#endif

#define SYS_BASE 0xb8000000
#define SYS_INI_STATUS (SYS_BASE +0x04)
#define SYS_HW_STRAP (SYS_BASE +0x08)
#define SYS_CLKMANAGE (SYS_BASE +0x10)
//hw strap
#define ST_SYNC_OCP_OFFSET 9
#define CK_M2X_FREQ_SEL_OFFSET 10
#define ST_CPU_FREQ_SEL_OFFSET 13
#define ST_CPU_FREQDIV_SEL_OFFSET 19
#define ST_BOOTPINSEL (1<<0)
#define ST_DRAMTYPE (1<<1)
#define ST_BOOTSEL (1<<2)
#define ST_PHYID (0x3<<3) //11b 
#define ST_EN_EXT_RST (1<<8)
#define ST_SYNC_OCP (1<<9)
#define CK_M2X_FREQ_SEL (0x7 <<10)
#define ST_CPU_FREQ_SEL (0xf<<13)
#define ST_NRFRST_TYPE (1<<17)
#define SYNC_LX (1<<18)
#define ST_CPU_FREQDIV_SEL (0x7<<19)
#define ST_EVER_REBOOT_ONCE (1<<23)
#define ST_SYS_DBG_SEL  (0x3f<<24)
#define ST_PINBUS_DBG_SEL (3<<30)
#define SPEED_IRQ_NO 29
#define SPEED_IRR_NO 3
#define SPEED_IRR_OFFSET 20
extern unsigned int	_end;

extern unsigned char 	ethfile[20];
extern struct arptable_t	arptable[MAX_ARP];
#define MAIN_PROMPT						"<RealTek>"
#define putchar(x)	serial_outc(x)
#define IPTOUL(a,b,c,d)	((a << 24)| (b << 16) | (c << 8) | d )


#define  Check_UART_DataReady() (rtl_inl(UART_LSR) & (1<<24))    /* add by alfa */
#define  Get_UART_Data() ((rtl_inl(UART_RBR) & 0xff000000)>>24)  /* add by alfa */
	
int YesOrNo(void);
int CmdHelp( int argc, char* argv[] );
int CmdDumpWord( int argc, char* argv[] );
int CmdDumpByte( int argc, char* argv[] ); //wei add
int CmdWriteWord( int argc, char* argv[] );
int CmdWriteByte( int argc, char* argv[] );
int CmdWriteHword( int argc, char* argv[] );
int CmdWriteAll( int argc, char* argv[] );
int CmdCmp(int argc, char* argv[]);
//int CmdEDl(int argc, char* argv[]);
//int CmdEUl(int argc, char* argv[]);
int CmdCfn(int argc, char* argv[]);

int CmdIp(int argc, char* argv[]);
int CmdPinCode(int argc, char* argv[]); /* add by alfa */
int CmdMac(int argc, char* argv[]); /* add by alfa */
int CmdSSID(int argc, char* argv[]); /* add by dvdchen */
int CmdPassPhrase(int argc, char* argv[]); /* add by dvdchen */
int CmdDownload(int argc, char* argv[]); /* add by alfa */
int CmdMemoryTest(int argc, char* argv[]); /* add by alfa */
//int CmdFle(int argc, char* argv[]);
int CmdFlw(int argc, char* argv[]);
int CmdFlr(int argc, char* argv[]);
int CmdLoad(int argc, char* argv[]);
int CmdAuto(int argc, char* argv[]);

int CmdNFlr(int argc, char* argv[]);
int CmdNFlw(int argc, char* argv[]);
//int CmdTimer(int argc, char* argv[]);
//int CmdMTC0SR(int argc, char* argv[]);  //wei add
//int CmdMFC0SR(int argc, char* argv[]);  //wei add
//int CmdTFTP(int argc, char* argv[]);  //wei add

//Ziv
#ifdef WRAPPER
//write bootcode to flash from my content
int CmdWB(int argc, char* argv[]);
#ifdef SPI_FLASH
int CmdSWB(int argc, char* argv[]);
#endif
extern char _bootimg_start, _bootimg_end;
#endif
#ifdef SPI_FLASH
int CmdSFlw(int argc, char* argv[]);
#endif

/*Cyrus Tsai*/
/*move to ehterboot.h
#define TFTP_SERVER 0
#define TFTP_CLIENT 1
*/
extern struct arptable_t  arptable_tftp[3];
/*Cyrus Tsai*/

extern int flasherase(unsigned long src, unsigned int length);
extern int flashwrite(unsigned long dst, unsigned long src, unsigned long length);
extern int flashread (unsigned long dst, unsigned long src, unsigned long length);

extern int write_data(unsigned long dst, unsigned long length, unsigned char *target);
extern int read_data (unsigned long src, unsigned long length, unsigned char *target);

/*Cyrus Tsai*/
extern unsigned long file_length_to_server;
extern unsigned long file_length_to_client;
extern unsigned long image_address; 
/*this is the file length, should extern to flash driver*/
/*Cyrus Tsai*/

#if defined(RTL865X) || defined(RTL8196B)
#define WRITE_MEM32(addr, val)   (*(volatile unsigned int *) (addr)) = (val)
#define WRITE_MEM16(addr, val)   (*(volatile unsigned short *) (addr)) = (val)
#define READ_MEM32(addr)         (*(volatile unsigned int *) (addr))

#define SWCORE_BASE      0xBB800000        
#define PCRAM_BASE       (0x4100+SWCORE_BASE)
#define PITCR                  (0x000+PCRAM_BASE)       /* Port Interface Type Control Register */
#define PCRP0                 (0x004+PCRAM_BASE)       /* Port Configuration Register of Port 0 */
#define PCRP1                 (0x008+PCRAM_BASE)       /* Port Configuration Register of Port 1 */
#define PCRP2                 (0x00C+PCRAM_BASE)       /* Port Configuration Register of Port 2 */
#define PCRP3                 (0x010+PCRAM_BASE)       /* Port Configuration Register of Port 3 */
#define PCRP4                 (0x014+PCRAM_BASE)       /* Port Configuration Register of Port 4 */
#define EnablePHYIf        (1<<0)                           /* Enable PHY interface.                    */
#endif
 
COMMAND_TABLE	MainCmdTable[] =
{
	{ "?"	  ,0, CmdHelp			, "HELP (?)				    : Print this help message"					},
	{ "HELP"  ,0, CmdHelp			, NULL																	},
	{ "D"	  ,2, CmdDumpWord		, "D <Address> <Len>"},
	{ "DB"	  ,2, CmdDumpByte		, "DB <Address> <Len>"}, //wei add	
	{ "EW",2, CmdWriteWord, "EW <Address> <Value1> <Value2>..."},
	{ "EH",2, CmdWriteHword, "EH <Address> <Value1> <Value2>..."},
	{ "EB",2, CmdWriteByte, "EB <Address> <Value1> <Value2>..."},
	{ "EC",2, CmdWriteAll, "EC <Address> <Value1> <Length>..."},
	{ "CMP",3, CmdCmp, "CMP: CMP <dst><src><length>"},
	{ "IPCONFIG",2, CmdIp, "IPCONFIG <TargetAddress>"},
	{ "PINCODE",2, CmdPinCode, "WPS PinCode <XXXXXXXX>"},/* add by alfa */	
	{ "MAC",2, CmdMac, "MAC <XX:XX:XX:XX:XX:XX>"}, /* add by alfa */
	{ "SSID",2, CmdSSID, "SSID <Value>"},	/* add by dvdchen */
	{ "PASSPHRASE",2, CmdPassPhrase, "PASSPHRASE <Value>"},	/* add by dvdchen */
	{ "DOWNLOAD",2, CmdDownload, "DOWNLOAD (Download image to target)"}, /* add by alfa */
	{ "MEMTEST",2, CmdMemoryTest, "MEMTEST (DRAM memory test,Until press ESC key)"}, /* add by alfa */ 

	{ "J"  ,1, CmdCfn			, "J: Jump to <TargetAddress>"											},
#ifndef RTL8197B
	{ "FLW"   ,3, CmdFlw			, "FLW: FLW <dst><src><length>"					},
	{ "FLR"   ,3, CmdFlr			, "FLR: FLR <dst><src><length>"					},
#endif
	{ "LOADADDR"   ,1, CmdLoad			, "LOADADDR: <Load Address>"					},
#ifndef RTL8197B
	{ "AUTOBURN"   ,1, CmdAuto			, "AUTOBURN: 0/1" },
#endif
	//{ "TIMER"   ,1, CmdTimer			, "TIMER: Timer Test" },	
//	{ "MTC0SR"   ,1, CmdMTC0SR			, "MTC0SR: MTC0SR <Value>>"					}, //wei add
//	{ "MFC0SR"   ,0, CmdMFC0SR			, "MFC0SR: MFC0SR "					}, //wei add	
#ifndef RTL_8652_5PORT
	//{ "TFTP"   ,0, CmdTFTP			, "TFTP: Start TFTP Server Listening "					}, //wei add		
#endif	
#ifdef SUPPORT_NAND
	{ "NFLR",3, CmdNFlr, "NFLR: NFLR <dst><src><length>"},
	{ "NFLW",3, CmdNFlw, "NFLW: NFLW <dst><src><length>"},
#endif

#ifdef WRAPPER
	{ "WB", 0, CmdWB, "WB: WB"},
#ifdef SPI_FLASH
	{ "SWB", 1, CmdSWB, "SWB <SPI cnt#> (<0>=1st_chip,<1>=2nd_chip): SPI Flash WriteBack (for MXIC/Spansion)"}, 	//JSW	
#endif
#endif
#ifdef SPI_FLASH
	{ "SFLW",4, CmdSFlw, "SFLW <SPI cnt#><dst_ROM_offset><src_RAM_addr><length_Byte> : Write offset-data to SPI from RAM"},	
#endif
};

#ifdef KLD 
int ps_led_blink = 0;
int ps_led_toggle = 0;
#define Set_GPIO_LED_ON()	(REG32(PEFGHDAT_REG) =  REG32(PEFGHDAT_REG)  & (~(1<<14)) )
#define Set_GPIO_LED_OFF()	(REG32(PEFGHDAT_REG) =  REG32(PEFGHDAT_REG)  | (1<<14))
#endif


int power_led_blink_slow = 0; /* add by alfa */
int power_led_blink_quick = 0; /* add by alfa */
int power_led_toggle = 0;/* add by alfa */ 
#define Get_GPIO_SW_IN() (!(REG32(PABCDDAT_REG) & (1<<SW_RESET_BUTTON)) )
static unsigned long	CurrentDumpAddress;
static unsigned long   sys_ipaddress;
//------------------------------------------------------------------------------
/********   caculate CPU clock   ************/
int check_cpu_speed(void);
void timer_init(void);
void timer_stop(void);
static void timer_interrupt(int num, void *ptr, struct pt_regs * reg);
struct irqaction irq_timer = {timer_interrupt, 0, 8, "timer", NULL, NULL};                                   
extern int flash_sector_erase(unsigned long addr);

static volatile unsigned int jiffies=0;


int reset_button_time = 0;
static void timer_interrupt(int num, void *ptr, struct pt_regs * reg)
{
	
	rtl_outl(TCIR,rtl_inl(TCIR));
	jiffies++;

    if( Get_GPIO_SW_IN() )
        ++reset_button_time;
    else
      {
       	if( reset_button_time > 50 )
       	  {
           	   reset_button_time = 0;
           	   flashinit();
           	  /* flash_sector_erase(0x08000);
               flash_sector_erase(0x0a000);
               flash_sector_erase(0x0c000);
               flash_sector_erase(0x0e000); */
               //flash_sector_erase(0x3f0000);
               flash_sector_erase(0x10000);
               prom_printf("Router Configuration Reset To Default \n");
               autoreboot();
           }
        else
           reset_button_time = 0;
       } 
   
	if (power_led_blink_slow) {
		if ((jiffies % 50) == 0) {
			if (power_led_toggle == 0) {
				power_led_toggle = 1;
				Set_POWER_LED_OFF();
			}
			else {
				power_led_toggle = 0;
				Set_POWER_LED_ON();
			}
		}
	}
	if (power_led_blink_quick) {
		if ((jiffies % 10) == 0) {
			if (power_led_toggle == 0) {
				power_led_toggle = 1;
				Set_POWER_LED_OFF();
			}
			else {
				power_led_toggle = 0;
				Set_POWER_LED_ON();
			}
		}
	}

}
volatile int get_timer_jiffies(void)
{

	return jiffies;
};


//------------------------------------------------------------------------------
void timer_init(void)
{
    /* Set timer mode and Enable timer */
    REG32(TCCNR_REG) = (1<<31) | (1<<30);	//using time0

	#define DIVISOR     0xE
	#define DIVF_OFFSET                         16		
    REG32(CDBR_REG) = (DIVISOR) << DIVF_OFFSET;
    

    /* Set timeout per msec */
#ifdef CONFIG_RTL8196B_FPGA
	int SysClkRate = 20000000;	 /* CPU 20MHz */
#else
	int SysClkRate = 200000000;	 /* CPU 200MHz */
#endif

	#define TICK_10MS_FREQ  100 /* 100 Hz */
	#define TICK_100MS_FREQ 1000 /* 1000 Hz */
	#define TICK_FREQ       TICK_10MS_FREQ	
    REG32(TC0DATA_REG) = (((SysClkRate / DIVISOR) / TICK_FREQ) + 1) <<8;		//set 10msec

       

    /* We must wait n cycles for timer to re-latch the new value of TC1DATA. */
	int c;	
	for( c = 0; c < DIVISOR; c++ );
	

      /* Set interrupt mask register */
    //REG32(GIMR_REG) |= (1<<8);	//request_irq() will set 

    /* Set interrupt routing register */
    REG32(IRR1_REG) = 0x00050004;  //uart:IRQ5,  time0:IRQ4

    
    /* Enable timer interrupt */
    REG32(TCIR_REG) = (1<<31);
}
//------------------------------------------------------------------------------
void timer_stop(void)
{
	// disable timer interrupt
	rtl_outl(TCCNR,0);
	rtl_outl(TCIR,0);
}


//------------------------------------------------------------------------------

__inline__ void
__delay(unsigned long loops)
{
	__asm__ __volatile__ (
		".set\tnoreorder\n"
		"1:\tbnez\t%0,1b\n\t"
		"subu\t%0,1\n\t"
		".set\treorder"
		:"=r" (loops)
		:"0" (loops));
}

/*
80007988 <__delay>:                                             
80007988:	1480ffff 	bnez	a0,80007988 <__delay>           
8000798c:	2484ffff 	addiu	a0,a0,-1                        
80007990:	03e00008 	jr	ra                                  
*/

//---------------------------------------------------------------------------
static unsigned long loops_per_jiffy = (1<<12);
#define LPS_PREC 8
#define HZ 100

int check_cpu_speed(void)
{
	unsigned long ticks, loopbit;
	int lps_precision = LPS_PREC;
      
  	request_IRQ(8, &irq_timer, NULL); 
       timer_init();	

	loops_per_jiffy = (1<<12);
	while (loops_per_jiffy <<= 1) {
		/* wait for "start of" clock tick */
		ticks = jiffies;
		while (ticks == jiffies)
			/* nothing */;
		/* Go .. */
		ticks = jiffies;
		__delay(loops_per_jiffy);
		ticks = jiffies - ticks;
		if (ticks)
			break;
	}
/* Do a binary approximation to get loops_per_jiffy set to equal one clock
   (up to lps_precision bits) */
	loops_per_jiffy >>= 1;
	loopbit = loops_per_jiffy;
	while ( lps_precision-- && (loopbit >>= 1) ) 
	{
		loops_per_jiffy |= loopbit;
		ticks = jiffies;
		while (ticks == jiffies);
		ticks = jiffies;
		__delay(loops_per_jiffy);
		if (jiffies != ticks)	/* longer than 1 tick */
			loops_per_jiffy &= ~loopbit;
	}
	
	//timer_stop();	//wei del, because not close timer
	//free_IRQ(8);
/* Round the value and print it */	
	//prom_printf("cpu run %d.%d MIPS\n", loops_per_jiffy/(500000/HZ),      (loops_per_jiffy/(5000/HZ)) % 100);
	return ((loops_per_jiffy/(500000/HZ))+1);
	
}
//---------------------------------------------------------------------------


/*
---------------------------------------------------------------------------
;				Monitor
---------------------------------------------------------------------------
*/
extern char** GetArgv(const char* string);

void monitor(void)
{
	char		buffer[ MAX_MONITOR_BUFFER +1 ];
	int		argc ;
	char**		argv ;
	int		i, retval ;
	
//	i = &_end;
//	i = (i & (~4095)) + 4096;
	//printf("Free Mem Start=%X\n", i);
	while(1)
	{	
		printf( "%s", MAIN_PROMPT );
		memset( buffer, 0, MAX_MONITOR_BUFFER );
		GetLine( buffer, MAX_MONITOR_BUFFER,1);
		printf( "\n" );
		argc = GetArgc( (const char *)buffer );
		argv = GetArgv( (const char *)buffer );
		if( argc < 1 ) continue ;
		StrUpr( argv[0] );
		for( i=0 ; i < (sizeof(MainCmdTable) / sizeof(COMMAND_TABLE)) ; i++ )
		{
			if( ! strcmp( argv[0], MainCmdTable[i].cmd ) )
			{
#if 0
				if (MainCmdTable[i].n_arg != (argc - 1))
					printf("%s\n", MainCmdTable[i].msg);
				else
					retval = MainCmdTable[i].func( argc - 1 , argv+1 );
#endif
				retval = MainCmdTable[i].func( argc - 1 , argv+1 );
				memset(argv[0],0,sizeof(argv[0]));
				break;
			}
		}
		if(i==sizeof(MainCmdTable) / sizeof(COMMAND_TABLE)) printf("Unknown command !\r\n");
	}
}


//---------------------------------------------------------------------------------------



//---------------------------------------------------------------------------------------


#ifdef WRAPPER
int CmdWB(int argc, char* argv[])
{
       char* start = &_bootimg_start;
	char* end  = &_bootimg_end;
        
	   
	unsigned int length = end - start;
	
	printf("Flash wille write %X length of embedded boot code at %X to %X\n", length, start, end);
	printf("(Y)es, (N)o->");
	if (YesOrNo())
		if (flashwrite(0, (unsigned long)start, length))
			printf("Flash Write Successed!\n");
		else
			printf("Flash Write Failed!\n");
	else
		printf("Abort!\n");

}


#ifdef SPI_FLASH
extern char _bootimg_start, _bootimg_end;
//SPI Write-Back
int CmdSWB(int argc, char* argv[])
{
	unsigned short auto_spi_clock_div_num;//0~7
	unsigned int  cnt=strtoul((const char*)(argv[0]), (char **)NULL, 16);	//JSW check
	char* start = &_bootimg_start;
	char* end  = &_bootimg_end;	   
	unsigned int length = end - start;		
	printf("SPI Flash #%d will write 0x%X length of embedded boot code from 0x%X to 0x%X\n", cnt+1,length, start, end);
	printf("(Y)es, (N)o->");
	if (YesOrNo())
	{
		spi_pio_init();	//JSW: Must add
		spi_flw_image(cnt, 0, start , length);
		/*Set SPI Parameter
	 	  SPI_CLK_DIV(0)= DRAM/(2) 
	 	  SPI_CLK_DIV(7)= DRAM/(16) default setting for booting out	
		*/
		printf("SPI Flash Burn OK!\n");
	}	
	else 
	{
        	printf("Abort!\n");	
	}	
  }
#endif
#endif
/*/
---------------------------------------------------------------------------
; Ethernet Download
---------------------------------------------------------------------------
*/




extern unsigned long ETH0_ADD;
int CmdCfn(int argc, char* argv[])
{
	unsigned long		Address;
	void	(*jump)(void);
	if( argc > 0 )
	{
		if(!Hex2Val( argv[0], &Address ))
		{
			printf(" Invalid Address(HEX) value.\n");
			return FALSE ;
		}
	}

	dprintf("---Jump to address=%X\n",Address);
	jump = (void *)(Address);
	outl(0,GIMR0); // mask all interrupt
	cli(); 
#ifndef RTL8186				  
//	rtl_outl(ETH0_ADD+ NIC_CNR1, 0 ); //sc_yang
#else
// add by arthur
// prevent from ethernet disturb Linux kernel booting
	{
		//printf("Disable eth0 before rebooting.....\n");
		unsigned int value;
	//	value = *(volatile unsigned int *)(0xbd201434);
		value = *(volatile unsigned int *)(0xb8019434);
		value = value & 0xffffff00;
	//	*(volatile unsigned int *)(0xbd201434) = value;
		*(volatile unsigned int *)(0xb8019434) = value;
	}
#endif
#if defined(RTL865X) || defined(RTL8196B)
#ifndef CONFIG_RTL8196B_FPGA
      /* if the jump-Address is BFC00000, then do watchdog reset */
      if(Address==0xBFC00000)
      	{
      	   *(volatile unsigned long *)(0xB800311c)=0; /*this is to enable 865xc watch dog reset*/
          for( ; ; );
      	}
     else /*else disable PHY to prevent from ethernet disturb Linux kernel booting */
     	{
           WRITE_MEM32(PCRP0, (READ_MEM32(PCRP0)&(~EnablePHYIf )) ); 
           WRITE_MEM32(PCRP1, (READ_MEM32(PCRP1)&(~EnablePHYIf )) ); 
           WRITE_MEM32(PCRP2, (READ_MEM32(PCRP2)&(~EnablePHYIf )) ); 
           WRITE_MEM32(PCRP3, (READ_MEM32(PCRP3)&(~EnablePHYIf )) ); 
           WRITE_MEM32(PCRP4, (READ_MEM32(PCRP4)&(~EnablePHYIf )) ); 
	flush_cache();
     	}
#endif
#endif
	jump();	
	
}
//---------------------------------------------------------------------------
/* This command can be used to configure host ip and target ip	*/

extern char eth0_mac[6];
int CmdIp(int argc, char* argv[])
{
	unsigned char  *ptr;
	unsigned int i;
	int  ip[4];
	
	if (argc==0)
	{	
		printf(" Target Address=%d.%d.%d.%d\n",
		arptable_tftp[TFTP_SERVER].ipaddr.ip[0], arptable_tftp[TFTP_SERVER].ipaddr.ip[1], 
		arptable_tftp[TFTP_SERVER].ipaddr.ip[2], arptable_tftp[TFTP_SERVER].ipaddr.ip[3]);
#ifdef HTTP_SERVER
		printf("   Http Address=%d.%d.%d.%d\n",
		arptable_tftp[HTTPD_ARPENTRY].ipaddr.ip[0], arptable_tftp[HTTPD_ARPENTRY].ipaddr.ip[1], 
		arptable_tftp[HTTPD_ARPENTRY].ipaddr.ip[2], arptable_tftp[HTTPD_ARPENTRY].ipaddr.ip[3]);
#endif
		return;	 
	}			
	
	ptr = argv[0];

	for(i=0; i< 4; i++)
	{
		ip[i]=strtol((const char *)ptr,(char **)NULL, 10);		
		ptr = strchr(ptr, '.');
		ptr++;
	}
	arptable_tftp[TFTP_SERVER].ipaddr.ip[0]=ip[0];
	arptable_tftp[TFTP_SERVER].ipaddr.ip[1]=ip[1];
	arptable_tftp[TFTP_SERVER].ipaddr.ip[2]=ip[2];
	arptable_tftp[TFTP_SERVER].ipaddr.ip[3]=ip[3];
/*replace the MAC address middle 4 bytes.*/
/* 
	eth0_mac[1]=ip[0];
	eth0_mac[2]=ip[1];
	eth0_mac[3]=ip[2];
	eth0_mac[4]=ip[3];
*/ /* mask by alfa */
	prom_printf("Now your Target IP is %d.%d.%d.%d\n", ip[0],ip[1],ip[2],ip[3]);
#if 0	
	ptr = argv[1];
	//prom_printf("You want to setup Host new ip as %s \n", ptr);	
	
	for(i=0; i< 4; i++)
	{
		ip[i]=strtol((const char *)ptr,(char **)NULL, 10);		
		ptr = strchr(ptr, '.');
		ptr++;
	}
	arptable[ARP_SERVER].ipaddr.ip[0]=ip[0];
	arptable[ARP_SERVER].ipaddr.ip[1]=ip[1];
	arptable[ARP_SERVER].ipaddr.ip[2]=ip[2];
	arptable[ARP_SERVER].ipaddr.ip[3]=ip[3];
	prom_printf("Now your Host IP is %d.%d.%d.%d\n", ip[0],ip[1],ip[2],ip[3]);
#endif	
		
}

int CmdPinCode(int argc, char* argv[])
{
	unsigned char  *ptr;
	unsigned int i;
	unsigned char tmpbuf[512];
    	unsigned short len;
	unsigned char sum=0;
	
	flashread(tmpbuf, 0x6000,512);
	memcpy(&len, &tmpbuf[4], 2);
	
	if (argc==0)
	{	
		prom_printf("WPS PinCode :%s\n",&tmpbuf[0x1a6]);
		return;	 
	}			
	
	ptr = argv[0];
	
	 if(strlen(ptr) < 8)
	  {
	  	prom_printf("PinCode number fail \n");
	  	return;
	  }
 
    memcpy(&tmpbuf[0x1a6],ptr,8);
    //tmpbuf[0x1a6+9] = NULL;
    tmpbuf[0x1a6+8] = NULL;
   
    for (i=4+2; i<4+2+len-1; i++) 
				sum += tmpbuf[i];
	sum = 0x100 - sum;
	tmpbuf[len+4+2-1] = sum;
	
	prom_printf("WPS PinCode :%s\n",&tmpbuf[0x1a6]);
	    
	flashwrite(0x6000, tmpbuf, len+4+2);
    
}		

#define SSID_OFFSET				0x13
#define PASSPHRASE_OFFSET		0x1f
#define MAX_SSID_LEN			11
#define MAX_PASSPHRASE_LEN	8

int CmdSSID(int argc, char* argv[])
{
	unsigned char  *ptr;
	unsigned int i;
	unsigned char tmpbuf[512];
    	unsigned short len, ssid_len;
	unsigned char sum=0;
	
	flashread(tmpbuf, 0x6000,512);
	memcpy(&len, &tmpbuf[4], 2);
	
	if (argc==0)
	{	
		prom_printf("SSID :%s\n",&tmpbuf[SSID_OFFSET]);
		return;
	}			
	
	ptr = argv[0];
	
	if( (ssid_len = strlen(ptr)) > MAX_SSID_LEN)
	{
		prom_printf("SSID length larger than %d, only %d chars would be recoreded\n", MAX_SSID_LEN, MAX_SSID_LEN);
		ssid_len = MAX_SSID_LEN;
	 }

 	memcpy(&tmpbuf[SSID_OFFSET], ptr, ssid_len);
    	tmpbuf[SSID_OFFSET + ssid_len ] = NULL;
    	//strncpy(&tmpbuf[SSID_OFFSET], ptr, ssid_len);  //at most 11 chars
   
    	for (i=4+2; i<4+2+len-1; i++) 
		sum += tmpbuf[i];
	sum = 0x100 - sum;
	tmpbuf[len+4+2-1] = sum;
	
	prom_printf("SSID :%s\n",&tmpbuf[SSID_OFFSET]);
	    
	flashwrite(0x6000, tmpbuf, len+4+2);
}

int CmdPassPhrase(int argc, char* argv[])
{
	unsigned char  *ptr;
	unsigned int i;
	unsigned char tmpbuf[512];
    	unsigned short len, phasephrase_len;
	unsigned char sum=0;
	
	flashread(tmpbuf, 0x6000,512);
	memcpy(&len, &tmpbuf[4], 2);
	
	if (argc==0)
	{	
		prom_printf("PASSPHRASE :%s\n",&tmpbuf[PASSPHRASE_OFFSET]);
		return;
	}			
	
	ptr = argv[0];
	
	if( (phasephrase_len = strlen(ptr)) > MAX_PASSPHRASE_LEN)
	{
		prom_printf("PASSPHRASE length larger than %d, only %d chars would be recoreded\n", 
					MAX_PASSPHRASE_LEN, MAX_PASSPHRASE_LEN);
	  	phasephrase_len = MAX_PASSPHRASE_LEN;
	 }

 	memcpy(&tmpbuf[PASSPHRASE_OFFSET], ptr, phasephrase_len);
    	tmpbuf[PASSPHRASE_OFFSET + phasephrase_len ] = NULL;
    	//strncpy(&tmpbuf[PASSPHRASE_OFFSET], ptr, phasephrase_len);
   
    	for (i=4+2; i<4+2+len-1; i++) 
		sum += tmpbuf[i];
	sum = 0x100 - sum;
	tmpbuf[len+4+2-1] = sum;
	
	prom_printf("PASSPHRASE :%s\n",&tmpbuf[PASSPHRASE_OFFSET]);
	    
	flashwrite(0x6000, tmpbuf, len+4+2);
}

int strToMac(unsigned char *pMac, char *pStr) /* add by alfa */
{
    unsigned char *ptr;
    unsigned int i,k;
    

    bzero(pMac,6);
    ptr = pStr;
    for(k=0;*ptr;ptr++)
    {
        if( (*ptr==':') || (*ptr=='-') )
            k++;
        else if( ('0'<=*ptr) && (*ptr<='9') )
            pMac[k]=(pMac[k]<<4)+(*ptr-'0');
        else if( ('a'<=*ptr) && (*ptr<='f') )
            pMac[k]=(pMac[k]<<4)+(*ptr-'a'+10);
        else if( ('A'<=*ptr) && (*ptr<='F') )
            pMac[k]=(pMac[k]<<4)+(*ptr-'A'+10);
        else
            break;
    }
    
    if(k!=5)
        return -1;
    
    return 0;
}

int check_esc(void)
{
 int i;
 	
  if(Check_UART_DataReady() )
	 {
	      i=Get_UART_Data();
		  Get_UART_Data();
          if( i == ESC ) 	
           {
		     printf("User Press ESC Break Key\r\n");
		     return 1;
           	}
          else 	
	 	     return 0; 
	} 	     
  else
     return 0;
}     	 

#define FILL(ptr,len,pattern) printf("Pattern: %08lX\n",pattern); \
             for (idx = 0; idx < len; idx++) ptr[idx] = pattern
			 	
#define CHECK(ptr,len,pattern) for (idx = 0; idx < len; idx++) { \
             if (ptr[idx]!=pattern) {printf("Mismatch at %08lX: Expected %08lX got %08lX\n", \
					   (uint32_t) (uint32_t *) &(ptr[idx]),pattern,ptr[idx]); \
                                           error = 1; loopmode = 0;break;} \
             }


#define MEMTEST(ptr,len,pattern) if (!error) { if(check_esc()) break;FILL(ptr,len,pattern) ; CHECK(ptr,len,pattern); }


int CmdMemoryTest(int argc, char* argv[])/* add by alfa */
{
    long addr = 0;
    int len = 0;
    int idx = 0;
    uint32_t *ptr;
    int error = 0;
    int loopmode = 0;
    int pass =0;
    int l = 0; /* add by alfa */
    char ans=0;
    loopmode = 1;
    pass = 0;
	
    
	printf("Doing memory test. \n");
	
    for (;;) {
              
		if(error)
		{
		  	printf("Memory Test fail \n"); 
		  	break;
		}	

		if(pass !=0)
	    		printf("Pass %d\n",pass);
	           

	    	len = 0x700000/4; 
	    	l = len ;
	    	addr = 0xa0000000;
        	ptr = (uint32_t *)addr;
        	printf("\nmemory test 0xa0000000 -- 0xa07fffff\n");
       
	    	MEMTEST(ptr,l,0x00000000L);
		    MEMTEST(ptr,l,0xFFFFFFFFL);
	    	MEMTEST(ptr,l,0x55555555L); 
	    	MEMTEST(ptr,l,0xAAAAAAAAL); 
	    	MEMTEST(ptr,l,0xFF00FF00L);
	    	MEMTEST(ptr,l,0x00FF00FFL);
	    	
	    	len = 0x1700000/4; 
	    	l = len ;
	    	addr = 0xa0900000;
        	ptr = (uint32_t *)addr;
        	
        	printf("\nmemory test 0xa0900000 -- 0xa1ffffff\n");
       
	    	MEMTEST(ptr,l,0x00000000L);
		    MEMTEST(ptr,l,0xFFFFFFFFL);
	    	MEMTEST(ptr,l,0x55555555L); 
	    	MEMTEST(ptr,l,0xAAAAAAAAL); 
	    	MEMTEST(ptr,l,0xFF00FF00L);
	    	MEMTEST(ptr,l,0x00FF00FFL);

		pass++;
	}

    return 0;
}


extern void tftpd_entry(void);
int CmdDownload(int argc, char* argv[])/* add by alfa */
{
	prom_printf("Waitting for TFTP Client ...\n");
 	tftpd_entry();
 }	

int CmdMac(int argc, char* argv[])/* add by alfa */
{
	unsigned char tmpbuf[512];
    unsigned short len;
	unsigned char sum=0;
	int i;
	unsigned char mac[6];
	char *ptr;
     
     flashread(tmpbuf, 0x6000,512);
	 memcpy(&len, &tmpbuf[4], 2);
	 
	 
	 if (len != 0 && len <= 512) {					
			for (i=4+2; i<4+2+len; i++) 
				sum += tmpbuf[i];
		}
		else
			sum = 1;
	
     if (sum == 0 && memcmp(&tmpbuf[4+2+1], "\x0\x0\x0\x0\x0\x0", 6)) {
			memcpy(arptable_tftp[0].node, &tmpbuf[4+2+1], 6);
			memcpy(eth0_mac, &tmpbuf[4+2+1], 6);
			memcpy(mac, &tmpbuf[4+2+1+6], 6);
		}
	
	
	if (argc==0)
	{	
		
		prom_printf("Lan Mac address is %02X:%02X:%02X:%02x:%02X:%02X \n",(unsigned char)eth0_mac[0],(unsigned char)eth0_mac[1],(unsigned char)eth0_mac[2],
		(unsigned char)eth0_mac[3],(unsigned char)eth0_mac[4],(unsigned char)eth0_mac[5]);
		prom_printf("Wan Mac address is %02X:%02X:%02X:%02x:%02X:%02X \n",(unsigned char)mac[0],(unsigned char)mac[1],(unsigned char)mac[2],
		(unsigned char)mac[3],(unsigned char)mac[4],(unsigned char)mac[5]);
		
		return;	 
	}			
	
	ptr = argv[0];
	
	if (strToMac(mac, ptr) == 0)
	 {
	    memcpy(&tmpbuf[4+2+1],mac,6);
	    
	    if( mac[5] == 0xff )
          {
           	mac[5] = 0x00;
                  	
           	if( mac[4] == 0xff )
           	  {
           	  	mac[4] = 0x00;
           	  	mac[3] = mac[3] + 1;
           	  }
            else
               mac[4] = mac[4] + 1;
          }
        else
          mac[5] = mac[5] + 1;
           
	    memcpy(&tmpbuf[4+2+1+6],mac,6);
	    
	    for (i=4+2; i<4+2+len-1; i++) 
				sum += tmpbuf[i];
	    sum = 0x100 - sum;
	    tmpbuf[len+4+2-1] = sum;
	    
	    memcpy(eth0_mac, &tmpbuf[4+2+1], 6);
	    memcpy(mac, &tmpbuf[4+2+1+6], 6);
	    
	    prom_printf("Chang Lan Mac address to  : %02X:%02X:%02X:%02x:%02X:%02X \n",(unsigned char)eth0_mac[0],(unsigned char)eth0_mac[1],
	                (unsigned char)eth0_mac[2],(unsigned char)eth0_mac[3],(unsigned char)eth0_mac[4],(unsigned char)eth0_mac[5]);
	    prom_printf("Chang Wan Mac address to  : %02X:%02X:%02X:%02x:%02X:%02X \n",(unsigned char)mac[0],(unsigned char)mac[1],
	                (unsigned char)mac[2],(unsigned char)mac[3],(unsigned char)mac[4],(unsigned char)mac[5]); 
	    
	    flashwrite(0x6000, tmpbuf, len+4+2);
	   	   
	    memcpy(arptable_tftp[0].node, &tmpbuf[4+2+1], 6);
	        
	 }
	else
	 printf("MAC address fail \n");   
		
}

/*int CmdEDl( int argc, char* argv[] )
{

	int			address;
	unsigned char 		iChar[2];
	int 	bytecount=0;
	
//	address = strtoul((const char*)(argv[1]), (char **)NULL, 16);	
//	prom_printf("Ethernet download %s to addr=%X\n? (Y/y/N/n)", argv[0], address);
	
		
//	GetLine( iChar, 2,1); 
//	if ((iChar[0] == 'Y') || (iChar[0] == 'y'))
//		printf("download! \n");
//	else
		printf("abort! \n");
	return TRUE;

}*/

/*int CmdEUl(int argc, char* argv[])
{

//	unsigned long		address;
//	unsigned long		bytecount;

//	unsigned char 		iChar[2];





//	address = strtoul((const char*)(argv[1]), (char **)NULL, 16);		
//	bytecount= strtoul((const char*)(argv[2]), (char **)NULL, 16);		

	
//	prom_printf("Ethernet upload %s from addr=%X with bytecount:%X\n? (Y/y/N/n)", 
//	argv[0], address,bytecount);	
	
//	GetLine( iChar, 2,1); 
//	if ((iChar[0] == 'Y') || (iChar[0] == 'y'))
//	        printf("\nUpload !\n");
//	else
	printf("abort! \n");
	
	
	return TRUE;
	
	
}*/

//---------------------------------------------------------------------------
int CmdDumpWord( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned int len,i;

	if(argc<1)
	{	dprintf("Wrong argument number!\r\n");
		return;
	}
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	if(!argv[1])
		len = 1;
	else
	len= strtoul((const char*)(argv[1]), (char **)NULL, 10);			
	while ( (src) & 0x03)
		src++;

	for(i=0; i< len ; i+=4,src+=16)
	{	
		printf("%X:	%X	%X	%X	%X\n",
		src, *(unsigned long *)(src), *(unsigned long *)(src+4), 
		*(unsigned long *)(src+8), *(unsigned long *)(src+12));
	}

}

//---------------------------------------------------------------------------
int CmdDumpByte( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned int len,i;

	if(argc<1)
	{	dprintf("Wrong argument number!\r\n");
		return;
	}
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	if(!argv[1])
		len = 16;
	else
	len= strtoul((const char*)(argv[1]), (char **)NULL, 10);			


	ddump((unsigned char *)src,len);
}

//---------------------------------------------------------------------------
int CmdWriteWord( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned int value,i;
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	while ( (src) & 0x03)
		src++;

	for(i=0;i<argc-1;i++,src+=4)
	{
		value= strtoul((const char*)(argv[i+1]), (char **)NULL, 16);	
		*(volatile unsigned int *)(src) = value;
	}
	
}
//---------------------------------------------------------------------------

int CmdWriteAll( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned int value,i;
	unsigned int length;
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	while ( (src) & 0x03)
		src++;

	i = 0;
	value = strtoul((const char*)(argv[1]), (char **)NULL, 16);	
	length = strtoul((const char*)(argv[2]), (char **)NULL, 16);	
	printf("Write %x to %x for length %d\n",value,src,length);
	for(i=0;i<length;i+=4,src+=4)
	{
		*(volatile unsigned int *)(src) = value;
	}
	
}
//---------------------------------------------------------------------------
int CmdWriteHword( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned short value,i;
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	
	src &= 0xfffffffe;	

	for(i=0;i<argc-1;i++,src+=2)
	{
		value= strtoul((const char*)(argv[i+1]), (char **)NULL, 16);	
		*(volatile unsigned short *)(src) = value;
	}
	
}

//---------------------------------------------------------------------------
int CmdWriteByte( int argc, char* argv[] )
{
	
	unsigned long src;
	unsigned char value,i;
	
	src = strtoul((const char*)(argv[0]), (char **)NULL, 16);		


	for(i=0;i<argc-1;i++,src++)
	{
		value= strtoul((const char*)(argv[i+1]), (char **)NULL, 16);	
		*(volatile unsigned char *)(src) = value;
	}
	
}
/*
--------------------------------------------------------------------------
Flash Utility
--------------------------------------------------------------------------
*/

#ifndef RTL8197B
int CmdFlw(int argc, char* argv[])
{
	unsigned long dst,src;
	unsigned long length;

#define FLASH_WRITE_BYTE 4096

	dst = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	src = strtoul((const char*)(argv[1]), (char **)NULL, 16);		
	length= strtoul((const char*)(argv[2]), (char **)NULL, 16);		
//	length= (length + (FLASH_WRITE_BYTE - 1)) & FLASH_WRITE_BYTE;

/*Cyrus Tsai*/
/*file_length_to_server;*/
//length=file_length_to_server;
//length=length & (~0xffff)+0x10000;
/*Cyrus Tsai*/

	
	printf("Flash Program from %X to %X with %X bytes	?\n",src,dst,length);
	printf("(Y)es, (N)o->");
	if (YesOrNo())
		if (flashwrite(dst, src, length))
			printf("Flash Write Successed!\n");
		else
			printf("Flash Write Failed!\n");
	else
		printf("Abort!\n");
#undef FLASH_WRITE_BYTE //4096
				
}

//---------------------------------------------------------------------------
int CmdFlr(int argc, char* argv[])
{
	int i;
	unsigned long dst,src;
	unsigned int length;
	//unsigned char TARGET;
//#define  FLASH_READ_BYTE	4096

	dst = strtoul((const char*)(argv[0]), (char **)NULL, 16);
	src = strtoul((const char*)(argv[1]), (char **)NULL, 16);
	length= strtoul((const char*)(argv[2]), (char **)NULL, 16);		
	//length= (length + (FLASH_READ_BYTE - 1)) & FLASH_READ_BYTE;

/*Cyrus Tsai*/
/*file_length_to_server;*/
//length=file_length_to_client;
//length=length & (~0xffff)+0x10000;
//dst=image_address;
file_length_to_client=length;
/*Cyrus Tsai*/

	printf("Flash read from %X to %X with %X bytes	?\n",src,dst,length);
	printf("(Y)es , (N)o ? --> ");

	if (YesOrNo())
	        //for(i=0;i<length;i++)
	        //   {
		//    if ( flashread(&TARGET, src+i,1) )
		//	printf("Flash Read Successed!, target %X\n",TARGET);
		//    else
		//	printf("Flash Read Failed!\n");
		//  }	
		    if (flashread(dst, src, length))
			printf("Flash Read Successed!\n");
		    else
			printf("Flash Read Failed!\n");
	else
		printf("Abort!\n");
//#undef	FLASH_READ_BYTE		4096

}
#endif //RTL8197B
//---------------------------------------------------------------------------
int CmdLoad(int argc, char* argv[])
{
	unsigned long addr;


	image_address= strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	printf("Set TFTP Load Addr 0x%x\n",image_address);
}
//---------------------------------------------------------------------------
#ifndef RTL8197B
extern int autoBurn;
int CmdAuto(int argc, char* argv[])
{
	unsigned long addr;


	if(argv[0][0] == '0')
		autoBurn = 0 ;
	else
		autoBurn = 1 ;
	printf("AutoBurning=%d\n",autoBurn);
}
#endif
#if 0
//---------------------------------------------------------------------------
int CmdTimer(int argc, char* argv[])
{
//	extern void timer_task(void);
//	timer_task();	
#if 1 //wei edit
	int i=0;
	dprintf("Endless loop, every 1 sec show a message.\r\n");
	while(1)
	{
		i=jiffies;
		if(i%100 ==0 )		
			dprintf("1 sec.\r\n");

		while(i==jiffies) ;

	}
#endif
#if 0		//memory read and write test
	
	unsigned int val=0;
	volatile unsigned long *p;
	//for(p=0x81000000; p< 0x82000000; p+=4)	//32M16b test 16M
	for(p=0x80f00000; p< 0x81000000; p+=4)	//16M test 8M	
	{	*p=p;
		if( *p != p)
			dprintf("Error Addr=%x, Read=%x\r\n", p, *p);

	}
#endif
	return TRUE;
	
}
#endif
//---------------------------------------------------------------------------
#if RTL_8652_5PORT
#if 0
int CmdMTC0SR(int argc, char* argv[])  //wei add
{
	unsigned long val;
//	unsigned long 	addr;

	val = strtoul((const char*)(argv[0]), (char **)NULL, 16);
//	addr = strtoul((const char*)(argv[1]), (char **)NULL, 10);
   
   write_32bit_cp0_register(CP0_STATUS, val);   
   __asm__ volatile("nop");
   __asm__ volatile("nop");   
	//printf("WWW TEST!!!\n");


}
//---------------------------------------------------------------------------
int CmdMFC0SR(int argc, char* argv[])  //wei add
{
//	unsigned long addr;
	volatile unsigned int reg;	
//	addr = strtoul((const char*)(argv[1]), (char **)NULL, 10);
	
	reg=read_32bit_cp0_register(CP0_STATUS); 
   __asm__ volatile("nop");	
   __asm__ volatile("nop");   
	printf("Move From CP0 Status Value is : 0x%X\n",reg);


}
#endif
#endif
//---------------------------------------------------------------------------
#if 0
int CmdTFTP(int argc, char* argv[])  //wei add
{
//	unsigned long addr;
	volatile unsigned int reg;	
//	addr = strtoul((const char*)(argv[1]), (char **)NULL, 10);
	
	eth_listening();	//do while(1) receive packet


}
#endif

/*
------------------------------------------  ---------------------------------
; Command Help
---------------------------------------------------------------------------
*/
  

#if 0
extern int flash_test(void);
#endif

int CmdHelp( int argc, char* argv[] )
{
	int	i, LineCount ;

    printf("----------------- COMMAND MODE HELP ------------------\n");
	for( i=0, LineCount = 0 ; i < (sizeof(MainCmdTable) / sizeof(COMMAND_TABLE)) ; i++ )
	{
		if( MainCmdTable[i].msg )
		{
			LineCount++ ;
			printf( "%s\n", MainCmdTable[i].msg );
			if( LineCount == PAGE_ECHO_HEIGHT )
			{
				printf("[Hit any key]\r");
				WaitKey();
				printf("	     \r");
				LineCount = 0 ;
			}
		}
	}
	/*Cyrus Tsai*/
#if 0
 	/*Cyrus Tsai*/
    flash_test();   
#endif    
    
	return TRUE ;
}



//---------------------------------------------------------------------------


int YesOrNo(void)
{
	unsigned char iChar[2];

	GetLine( iChar, 2,1);
	printf("\n");//vicadd
	if ((iChar[0] == 'Y') || (iChar[0] == 'y'))
		return 1;
	else
		return 0;
}
//---------------------------------------------------------------------------
int CmdCmp(int argc, char* argv[])
{
	int i;
	unsigned long dst,src;
	unsigned long dst_value, src_value;
	unsigned int length;
	unsigned long error;

	if(argc < 3) {
		printf("Parameters not enough!\n");
		return 1;
	}
	dst = strtoul((const char*)(argv[0]), (char **)NULL, 16);
	src = strtoul((const char*)(argv[1]), (char **)NULL, 16);
	length= strtoul((const char*)(argv[2]), (char **)NULL, 16);		
	error = 0;
	for(i=0;i<length;i+=4) {
		dst_value = *(volatile unsigned int *)(dst+i);
		src_value = *(volatile unsigned int *)(src+i);
		if(dst_value != src_value) {		
			printf("%dth data(%x %x) error\n",i, dst_value, src_value);
			error = 1;
		}
	}
	if(!error)
		printf("No error found\n");

}

#ifdef SPI_FLASH
int CmdSFlw(int argc, char* argv[])
{
	unsigned int  cnt2=strtoul((const char*)(argv[0]), (char **)NULL, 16);	
	unsigned int  dst_flash_addr_offset=strtoul((const char*)(argv[1]), (char **)NULL, 16);		
	unsigned int  src_RAM_addr=strtoul((const char*)(argv[2]), (char **)NULL, 16);
	unsigned int  length=strtoul((const char*)(argv[3]), (char **)NULL, 16);
	unsigned int  end_of_RAM_addr=src_RAM_addr+length;	
	printf("Write 0x%x Bytes to SPI flash#%d, offset 0x%x<0x%x>, from RAM 0x%x to 0x%x\n" ,length,cnt2+1,dst_flash_addr_offset,dst_flash_addr_offset+0xbd000000,src_RAM_addr,end_of_RAM_addr);
	printf("(Y)es, (N)o->");
	if (YesOrNo())
	{
	   spi_pio_init();	//JSW: Must add
	   spi_flw_image(cnt2, dst_flash_addr_offset, src_RAM_addr , length);	 
	}//end if YES
	else
		printf("Abort!\n");
}
#endif
//---------------------------------------------------------------------------
#ifdef SUPPORT_NAND 

int CmdNFlr(int argc, char* argv[])
{
	int i;
	unsigned long dst,src;
	unsigned int length;

	if(argc < 3) {
		printf("Parameters not enough!\n");
		return 1;
	}

	dst = strtoul((const char*)(argv[0]), (char **)NULL, 16);
	src = strtoul((const char*)(argv[1]), (char **)NULL, 16);
	length= strtoul((const char*)(argv[2]), (char **)NULL, 16);		

	file_length_to_client=length;

	printf("Read NAND Flash from %X to %X with %X bytes	?\n",src,dst,length);
	printf("(Y)es , (N)o ? --> ");

	if (YesOrNo())
		    if (read_data(src,length,(unsigned char *)dst))
			printf("Read NAND Flash Successed!\n");
		    else
			printf("Read NAND Flash Failed!\n");
	else
		printf("Abort!\n");

}
//---------------------------------------------------------------------------
int CmdNFlw(int argc, char* argv[])
{
	unsigned long dst,src;
	unsigned long length;


	if(argc < 3) {
		printf("Parameters not enough!\n");
		return 1;
	}
	dst = strtoul((const char*)(argv[0]), (char **)NULL, 16);		
	src = strtoul((const char*)(argv[1]), (char **)NULL, 16);		
	length= strtoul((const char*)(argv[2]), (char **)NULL, 16);		

	printf("Program NAND flash from %X to %X with %X bytes	?\n",src,dst,length);
	printf("(Y)es, (N)o->");
	if (YesOrNo())
		if (write_data(dst, length, src))
			printf("Write Nand Flash Successed!\n");
		else
			printf("Write Nand Flash Failed!\n");
	else
		printf("Abort!\n");
				
}
#endif
