#!/bin/sh
. /www/cgi-bin/functions.sh
. /www/cgi-bin/webupgrade.sh
. /www/cgi-bin/change_language.sh
eval "`/www/cgi-bin/proccgi $*`"

wan_proto=$($nvram get wan_proto)
wan_pppoe_demand=$($nvram get wan_pppoe_demand)  
wan_pptp_demand=$($nvram get wan_pptp_demand)  
wan_status=$([ -f /tmp/ppp/ppp0-status ] && cat /tmp/ppp/ppp0-status || echo "0")

detwan_restart=0
ew_detwan_restart=0
auto_detwan_restart=0
down_confile_restart=0
auto_down_confile_restart=0
down_confile_language_restart=0
download_image_restart=0
download_language_restart=0
refreshed_page=${QUERY_STRING}
FIRMWARE_OR_LANGUAGE="firmware"
case "$FORM_submit_flag" in
	welcome_detwan)
                $nvram set welcome_wan_type=0
                detwan_restart=$(($detwan_restart+1))
                ;;
        wizard_detwan)
                $nvram set welcome_wan_type=0
                detwan_restart=$(($detwan_restart+1))
                ;;
        easy_wizard_detwan)
                $nvram set welcome_wan_type=0
                #$nvram unset detwan_first_do
                ew_detwan_restart=$(($ew_detwan_restart+1))
                ;;
        auto_upgrade_detwan)
                auto_detwan_restart=$(($auto_detwan_restart+1))
								;;
        download_confile)
				FIRMWARE_OR_LANGUAGE="firmware"
                down_confile_restart=$(($down_confile_restart+1))
                ;;
        auto_download_confile)
				FIRMWARE_OR_LANGUAGE="firmware"
                auto_down_confile_restart=$(($auto_down_confile_restart+1))
                ;;
		download_language_confile)
				FIRMWARE_OR_LANGUAGE="language"
				down_confile_language_restart=$(($down_confile_language_restart+1))
				;;
        download_image)
                download_image_restart=$(($download_image_restart+1))
                ;;
		download_language)
				download_language_restart=$(($download_language_restart+1))
				;;
        logs_clear)
		echo -n "" > /var/log/messages
		logger -- [Log Cleared]
		;;
        logs_send)
	    	. $logsh
		logs_send
		;;
    *)
        refreshed_page="${refreshed_page}"
        ;;
esac

if [ "$down_confile_restart" -gt "0" ];then
	if [ "$wan_proto" = "pppoe" ] && [ "$wan_pppoe_demand" = "1" ] && [ "$wan_status" = "0" ];then
		print_http_refresh "http://${HTTP_HOST}${refreshed_page}" "15"
	elif [ "$wan_proto" = "pptp" ] && [ "$wan_pptp_demand" = "1" ] && [ "$wan_status" = "0" ];then
		print_http_refresh "http://${HTTP_HOST}${refreshed_page}" "15"
	else
		print_http_refresh "http://${HTTP_HOST}${refreshed_page}" "2"
	fi
else
	print_http_refresh "http://${HTTP_HOST}${refreshed_page}" "2"
fi

exec >&-

if [ $detwan_restart -gt 0 ];then
        oc /sbin/detwan &> /dev/null &
fi

if [ $ew_detwan_restart -gt 0 ];then
        oc /sbin/detwan 1 &> /dev/null &
fi

if [ $auto_detwan_restart -gt 0 ];then
        /www/cgi-bin/test_wan_status.sh "$FIRMWARE_OR_LANGUAGE "&> /dev/null &
fi

if [ $down_confile_restart -gt 0 ];then
	oc echo "FIRMWARE_OR_LANGUAGE=$FIRMWARE_OR_LANGUAGE"
	if [ "$wan_proto" = "pppoe" ] && [ "$wan_pppoe_demand" = "1" ] && [ "$wan_status" = "0" ];then
		oc /bin/ping -c 1 206.82.202.46		#www.netgear.com 
	elif [ "$wan_proto" = "pptp" ] && [ "$wan_pptp_demand" = "1" ] && [ "$wan_status" = "0" ];then
		oc /bin/ping -c 1 206.82.202.46   #www.netgear.com 
	fi
  /www/cgi-bin/test_wan_status.sh "$FIRMWARE_OR_LANGUAGE" &> /dev/null &
fi

if [ $auto_down_confile_restart -gt 0 ];then
		oc echo "FIRMWARE_OR_LANGUAGE=$FIRMWARE_OR_LANGUAGE"
        /www/cgi-bin/test_wan_status.sh "$FIRMWARE_OR_LANGUAGE" &> /dev/null &
fi

if [ $down_confile_language_restart -gt 0 ];then
		oc echo "FIRMWARE_OR_LANGUAGE=$FIRMWARE_OR_LANGUAGE"
		oc /www/cgi-bin/fast_test_wan_status.sh "$FIRMWARE_OR_LANGUAGE" 
fi
	
if [ $download_image_restart -gt 0 ];then
        /www/cgi-bin/webupgrade_get_image.sh &> /dev/null &
fi
if [ $download_language_restart -gt 0 ];then
		/www/cgi-bin/webupgrade_get_language_table.sh 
		/bin/mv $LANGUAGE_TABLE_FILE $PRE_LANGUAGE_TABLE
		language_table_upgrade
fi
	
